unit LexCounterU;

interface

uses
  Dialogs, Buttons, jpeg, ExtCtrls, StdCtrls, Mask, ComCtrls, Controls,
  Classes, Forms, Windows, SysUtils;

type
  TLexCounterF = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    PrintDialog1: TPrintDialog;
    TabSheet4: TTabSheet;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    Label2: TLabel;
    Panel1: TPanel;
    Button1: TButton;
    Button4: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Total: TLabel;
    LPorcentagem: TLabel;
    LCusto: TLabel;
    lbc: TLabel;
    lbp: TLabel;
    Black: TLabel;
    Label5: TLabel;
    LpColorido: TLabel;
    LcColorido: TLabel;
    lyc: TLabel;
    lyp: TLabel;
    Yellow: TLabel;
    Magenta: TLabel;
    lmp: TLabel;
    lmc: TLabel;
    lcc: TLabel;
    lcp: TLabel;
    Cyan: TLabel;
    Panel3: TPanel;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    Panel4: TPanel;
    Image1: TImage;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    GroupBox3: TGroupBox;
    gravar: TButton;
    Visualizar: TButton;
    Button3: TButton;
    Imprimir: TButton;
    PrecoPreto: TMaskEdit;
    PrecoCor: TMaskEdit;
    RichEdit1: TRichEdit;
    Label15: TLabel;
    Label21: TLabel;
    Bevel4: TBevel;
    Panel5: TPanel;
    Edit1: TEdit;
    Button5: TButton;
    GroupBox5: TGroupBox;
    Label3: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    PontosPreto1: TMaskEdit;
    PontosPreto2: TMaskEdit;
    PontosCor2: TMaskEdit;
    PontosCor1: TMaskEdit;
    PontosPretoZ1: TMaskEdit;
    PontosPretoZ2: TMaskEdit;
    PontosCorZ2: TMaskEdit;
    PontosCorZ1: TMaskEdit;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Bevel1: TBevel;
    Label20: TLabel;
    Label22: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure gravarClick(Sender: TObject);
    procedure VisualizarClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ImprimirClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure GravaInformacoes;
    procedure Valores;
    procedure Button4Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure PrecoCorKeyPress(Sender: TObject; var Key: Char);
    procedure Button5Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LexCounterF: TLexCounterF;
  PixelColor,PixelBlack,PrecoBlack,PrecoColor: Real;
  b1,b2,c1,c2,m1,m2,y1,y2: Integer;
  Diretorio: array [0..255] of Char;
  BcoDados: Textfile;
  Dados: String;

implementation

{$R *.DFM}

procedure LimpaTela;
begin
  LexCounterF.lcp.caption:='';
  LexCounterF.lmp.caption:='';
  LexCounterF.lcp.caption:='';
  LexCounterF.lyp.caption:='';
  LexCounterF.lbp.caption:='';
  LexCounterF.lcc.caption:='';
  LexCounterF.lmc.caption:='';
  LexCounterF.lyc.caption:='';
  LexCounterF.lbc.caption:='';
  LexCounterF.lPorcentagem.caption:='';
  LexCounterF.lCusto.caption:='';
  LexCounterF.lpColorido.caption:='';
  LexCounterF.lcColorido.caption:='';
end;

procedure TLexCounterF.GravaInformacoes;
var
  Temp: Integer;
begin
  Temp:=0;
  if RadioButton1.Checked then Temp:=1;
  if RadioButton2.Checked then Temp:=2;
  if RadioButton3.Checked then Temp:=3;
  if RadioButton4.Checked then Temp:=4;
  AssignFile(BcoDados,Diretorio+'\LexCounter.stc');
  Rewrite(BcoDados);
  Writeln(BcoDados,PrecoPreto.Text);
  Writeln(BcoDados,PrecoCor.Text);
  Writeln(BcoDados,PontosPreto1.Text);
  Writeln(BcoDados,PontosCor1.Text);
  Writeln(BcoDados,PontosPreto2.Text);
  Writeln(BcoDados,PontosCor2.Text);
  Writeln(BcoDados,PontosPretoZ1.Text);
  Writeln(BcoDados,PontosCorZ1.Text);
  Writeln(BcoDados,PontosPretoZ2.Text);
  Writeln(BcoDados,PontosCorZ2.Text);
  Writeln(BcoDados,IntToStr(Temp));
  Writeln(BcoDados,IntToStr(LexCounterF.Left));
  Writeln(BcoDados,IntToStr(LexCounterF.Top));  
  CloseFile(BcoDados);
end;

procedure TLexCounterF.Valores;
Label Salto;
begin
  if (RadioButton1.Checked) or (RadioButton2.Checked) then
    begin
      AssignFile(BcoDados,Diretorio+'\Win.Ini');
      Reset(BcoDados);
      while(not Eof(BcoDados)) do
        begin
          Readln(BcoDados,Dados);
          if Copy(Dados,1,9)='Black Dot' then b2:=StrToInt(Copy(Dados,17,10));
          if Copy(Dados,1,8)='Cyan Dot' then c2:=StrToInt(Copy(Dados,16,10));
          if Copy(Dados,1,11)='Magenta Dot' then m2:=StrToInt(Copy(Dados,19,10));
          if Copy(Dados,1,10)='Yellow Dot' then
            begin
              y2:=StrToInt(Copy(Dados,18,10));
              if (RadioButton1.Checked) then
                begin
                  CloseFile(BcoDados);
                  goto Salto;
                end;
            end;
        end;
      CloseFile(BcoDados);
    end;
  if (RadioButton3.Checked) or (RadioButton4.Checked) then
    begin
      AssignFile(BcoDados,Diretorio+'\Lexhbp.Ini');
      Reset(BcoDados);
      while(not Eof(BcoDados)) do
        begin
          Readln(BcoDados,Dados);
          if Copy(Dados,1,8)='Cyan Dot' then c2:=StrToInt(Copy(Dados,16,10));
          if Copy(Dados,1,11)='Magenta Dot' then m2:=StrToInt(Copy(Dados,19,10));
          if Copy(Dados,1,10)='Yellow Dot' then y2:=StrToInt(Copy(Dados,18,10));
          if Copy(Dados,1,9)='Black Dot' then
            begin
              b2:=StrToInt(Copy(Dados,17,15));
              if (RadioButton3.Checked) then
                begin
                  CloseFile(BcoDados);
                  goto Salto;
                end;
            end;
        end;
      CloseFile(BcoDados);
    end;
  Salto:
  if (b1<>b2) or (c1<>c2) or (m1<>m2) or (y1<>y2) then
    begin
      Lporcentagem.caption:=FloatToStrF((b2-b1)/PixelBlack+(c2-c1+m2-m1+y2-y1)/PixelColor/3,ffnumber,3,2)+'%';
      LpColorido.caption:=FloatToStrF((c2-c1+m2-m1+y2-y1)/PixelColor/3,ffnumber,3,2)+'%';
      lbp.caption:=FloatToStrF((b2-b1)/PixelBlack,ffnumber,3,2)+'%';
      lcp.caption:=FloatToStrF((c2-c1)/PixelColor,ffnumber,3,2)+'%';
      lmp.caption:=FloatToStrF((m2-m1)/PixelColor,ffnumber,3,2)+'%';
      lyp.caption:=FloatToStrF((y2-y1)/PixelColor,ffnumber,3,2)+'%';
      LCusto.Caption:=FloatToStrF(((b2-b1)/PixelBlack*PrecoBlack+(c2-c1+m2-m1+y2-y1)/PixelColor*PrecoColor)/100,ffcurrency,3,2);
      LcColorido.caption:=FloatToStrF((c2-c1+m2-m1+y2-y1)/PixelColor*PrecoColor/100,ffcurrency,3,2);
      lbc.caption:=FloatToStrF((b2-b1)/PixelBlack*PrecoBlack/100,ffcurrency,3,2);
      lcc.caption:=FloatToStrF((c2-c1)/PixelColor*PrecoColor/100,ffcurrency,3,2);
      lmc.caption:=FloatToStrF((m2-m1)/PixelColor*PrecoColor/100,ffcurrency,3,2);
      lyc.caption:=FloatToStrF((y2-y1)/PixelColor*PrecoColor/100,ffcurrency,3,2);
    end
  else Label1.Caption:='Nenhuma Impresso!';
end;

procedure TLexCounterF.Button1Click(Sender: TObject);
Label Salto;
begin
  LimpaTela;
  b2:=0;
  c2:=0;
  m2:=0;
  y2:=0;
  if (RadioButton1.Checked) or (RadioButton2.Checked) then
    begin
      AssignFile(BcoDados,Diretorio+'\Win.Ini');
      Reset(BcoDados);
      while(not Eof(BcoDados)) do
        begin
          Readln(BcoDados,Dados);
          if Copy(Dados,1,9)='Black Dot' then b1:=StrToInt(Copy(Dados,17,10));
          if Copy(Dados,1,8)='Cyan Dot' then c1:=StrToInt(Copy(Dados,16,10));
          if Copy(Dados,1,11)='Magenta Dot' then m1:=StrToInt(Copy(Dados,19,10));
          if Copy(Dados,1,10)='Yellow Dot' then
            begin
              y1:=StrToInt(Copy(Dados,18,10));
              if (RadioButton1.Checked) then
                begin
                  CloseFile(BcoDados);
                  goto Salto;
                end;
            end;
        end;
      CloseFile(BcoDados);
    end;
  if (RadioButton3.Checked) or (RadioButton4.Checked) then
    begin
      AssignFile(BcoDados,Diretorio+'\Lexhbp.Ini');
      Reset(BcoDados);
      while(not Eof(BcoDados)) do
        begin
          Readln(BcoDados,Dados);
          if Copy(Dados,1,8)='Cyan Dot' then c1:=StrToInt(Copy(Dados,16,10));
          if Copy(Dados,1,11)='Magenta Dot' then m1:=StrToInt(Copy(Dados,19,10));
          if Copy(Dados,1,10)='Yellow Dot' then y1:=StrToInt(Copy(Dados,18,10));
          if Copy(Dados,1,9)='Black Dot' then
            begin
              b1:=StrToInt(Copy(Dados,17,15));
              if (RadioButton3.Checked) then
                begin
                  CloseFile(BcoDados);
                  goto Salto;
                end;
            end;
        end;
      CloseFile(BcoDados);
    end;
  Salto:
  Button2.Enabled:=True;
  Button4.Enabled:=True;
  Label1.Caption:='Aguardando Impresso...';
end;

procedure TLexCounterF.Button2Click(Sender: TObject);
begin
  Button2.Enabled:=False;
  Button4.Enabled:=False;
  Label1.caption:='Custo da Impresso Calculado';
  Valores;
end;

procedure TLexCounterF.FormDestroy(Sender: TObject);
begin
  LoadLibrary('OLEAUT32');
  LoadLibrary('COMDLG32');
end;

procedure TLexCounterF.FormCreate(Sender: TObject);
begin
  FreeLibrary(GetModuleHandle('OLEAUT32'));
  FreeLibrary(GetModuleHandle('COMDLG32'));
  LimpaTela;
  GetWindowsDirectory(Diretorio,144);
  if not(FileExists(Diretorio+'\LexCounterText.stc')) then RichEdit1.Lines.SaveToFile(Diretorio+'\LexCounterText.stc');
  if FileExists(Diretorio+'\LexCounter.stc') then
    begin
      AssignFile(BcoDados,Diretorio+'\LexCounter.stc');
      Reset(BcoDados);
      Readln(BcoDados,Dados);
      PrecoPreto.Text:=Dados;
      Readln(BcoDados,Dados);
      PrecoCor.Text:=Dados;
      Readln(BcoDados,Dados);
      PontosPreto1.Text:=Dados;
      Readln(BcoDados,Dados);
      PontosCor1.Text:=Dados;
      Readln(BcoDados,Dados);
      PontosPreto2.Text:=Dados;
      Readln(BcoDados,Dados);
      PontosCor2.Text:=Dados;
      Readln(BcoDados,Dados);
      PontosPretoZ1.Text:=Dados;
      Readln(BcoDados,Dados);
      PontosCorZ1.Text:=Dados;
      Readln(BcoDados,Dados);
      PontosPretoZ2.Text:=Dados;
      Readln(BcoDados,Dados);
      PontosCorZ2.Text:=Dados;
      Readln(BcoDados,Dados);
      if Dados='1' then RadioButton1.Checked:=True;
      if Dados='2' then RadioButton2.Checked:=True;
      if Dados='3' then RadioButton3.Checked:=True;
      if Dados='4' then RadioButton4.Checked:=True;
      Readln(BcoDados,Dados);
      LexCounterF.Left:=StrToInt(Dados);
      Readln(BcoDados,Dados);
      LexCounterF.Top:=StrToInt(Dados);
      CloseFile(BcoDados);
    end
  else LexCounterF.Position:=poScreenCenter;
  PrecoBlack:=StrToInt(PrecoPreto.Text);
  PrecoColor:=StrToInt(PrecoCor.Text)/3;
  if RadioButton1.Checked then
    begin
      PixelBlack:=StrToInt(PontosPreto1.Text)/100;
      PixelColor:=StrToInt(PontosCor1.Text)/100;
    end;
  if RadioButton2.Checked then
    begin
      PixelBlack:=StrToInt(PontosPreto2.Text)/100;
      PixelColor:=StrToInt(PontosCor2.Text)/100;
    end;
  if RadioButton3.Checked then
    begin
      PixelBlack:=StrToInt(PontosPretoZ1.Text)/100;
      PixelColor:=StrToInt(PontosCorZ1.Text)/100;
    end;
  if RadioButton4.Checked then
    begin
      PixelBlack:=StrToInt(PontosPretoZ2.Text)/100;
      PixelColor:=StrToInt(PontosCorZ2.Text)/100;
    end;
end;

procedure TLexCounterF.BitBtn6Click(Sender: TObject);
begin
  GravaInformacoes;
  Application.Terminate;
end;

procedure TLexCounterF.PageControl1Change(Sender: TObject);
begin
  if TabSheet2.CanFocus then
  if (b1<>b2) or (c1<>c2) or (m1<>m2) or (y1<>y2) then Gravar.Enabled:=True;
  if TabSheet1.CanFocus then
    begin
      if RadioButton1.Checked then
        begin
          PixelBlack:=StrToInt(PontosPreto1.Text)/100;
          PixelColor:=StrToInt(PontosCor1.Text)/100;
        end;
      if RadioButton2.Checked then
        begin
          PixelBlack:=StrToInt(PontosPreto2.Text)/100;
          PixelColor:=StrToInt(PontosCor2.Text)/100;
        end;
      if RadioButton3.Checked then
        begin
          PixelBlack:=StrToInt(PontosPretoZ1.Text)/100;
          PixelColor:=StrToInt(PontosCorZ1.Text)/100;
        end;
      if RadioButton4.Checked then
        begin
          PixelBlack:=StrToInt(PontosPretoZ2.Text)/100;
          PixelColor:=StrToInt(PontosCorZ2.Text)/100;
        end;
    end;
end;

procedure TLexCounterF.gravarClick(Sender: TObject);
begin
  if (b1<>b2) or (c1<>c2) or (m1<>m2) or (y1<>y2) then
    begin
      Gravar.Enabled:=False;
      Panel5.Visible:=True;
      Edit1.SetFocus;
    end;
end;

procedure TLexCounterF.VisualizarClick(Sender: TObject);
begin
  RichEdit1.Clear;
  RichEdit1.Lines.LoadFromFile(Diretorio+'\LexCounterText.stc');
end;

procedure TLexCounterF.Button3Click(Sender: TObject);
begin
  DeleteFile(Diretorio+'\LexCounterText.stc');
  RichEdit1.Clear;
  RichEdit1.Lines.SaveToFile(Diretorio+'\LexCounterText.stc');
end;

procedure TLexCounterF.ImprimirClick(Sender: TObject);
begin
  if PrintDialog1.Execute then RichEdit1.Print(Diretorio+'\LexCounterText.stc');
end;

procedure TLexCounterF.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GravaInformacoes;
end;

procedure TLexCounterF.Button4Click(Sender: TObject);
begin
  Label1.caption:='Prvia do Custo Calculado';
  Valores;
end;

procedure TLexCounterF.BitBtn7Click(Sender: TObject);
var
  Help1: String;
  Help2: array [0..255] of Char;
begin
  Help1:=Diretorio+'\LexCounter.hlp';
  StrPCopy(Help2,Help1);
  WinHelp(Application.Handle,Help2,Help_Contents,SW_Normal);
end;

procedure TLexCounterF.PrecoCorKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key='.') or (Key=',') then key:=#0;
end;

procedure TLexCounterF.Button5Click(Sender: TObject);
begin
  Panel5.Visible:=False;
  with RichEdit1 do
    begin
      Lines.LoadFromFile(Diretorio+'\LexCounterText.stc');
      Lines.Add(Edit1.Text);
      Lines.Add('Ciano:'+chr(9)+chr(9)+Lcp.Caption+chr(9)+Lcc.Caption);
      Lines.Add('Magenta:'+chr(9)+chr(9)+Lmp.Caption+chr(9)+Lmc.Caption);
      Lines.Add('Amarelo:'+chr(9)+chr(9)+Lyp.Caption+chr(9)+Lyc.Caption);
      Lines.Add('Preto:'+chr(9)+chr(9)+Lbp.Caption+chr(9)+Lbc.Caption);
      Lines.Add('Total:'+chr(9)+chr(9)+LPorcentagem.Caption+chr(9)+LCusto.Caption);
      Lines.Add('');
      Lines.SaveToFile(Diretorio+'\LexCounterText.stc');
    end;
end;

procedure TLexCounterF.RadioButton1Click(Sender: TObject);
begin
  b1:=0; c1:=0; m1:=0; y1:=0;
  b2:=0; c2:=0; m2:=0; y2:=0;
end;

end.
